/*
 * Conver.java
 */

package Cap02.Conver;

/**
 *
 * @autor  Fco. Javier Ceballos
 * @versión 1.0
 */
public class Conver extends javax.swing.JFrame
{
  /** Crear un nuevo formulario Conver */
  public Conver()
  {
    setSize(300, 200);                      // tamaño del formulario
    setTitle("Conversión de temperaturas"); // título del formulario
    initComponents();                       // iniciar componentes
  }
  
  /** Este método es llamado por el constructor para
   *  iniciar el formulario.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jlbGradosC = new javax.swing.JLabel();
    jtfGradosC = new javax.swing.JTextField();
    jlbGradosF = new javax.swing.JLabel();
    jtfGradosF = new javax.swing.JTextField();
    jbtAceptar = new javax.swing.JButton();

    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        exitForm(evt);
      }
      public void windowOpened(java.awt.event.WindowEvent evt) {
        formWindowOpened(evt);
      }
    });
    getContentPane().setLayout(null);

    jlbGradosC.setText("Grados centígrados");
    getContentPane().add(jlbGradosC);
    jlbGradosC.setBounds(12, 28, 116, 14);

    jtfGradosC.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    jtfGradosC.setText("0.00");
    jtfGradosC.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(java.awt.event.FocusEvent evt) {
        jtfGradosFocusGained(evt);
      }
    });
    jtfGradosC.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyTyped(java.awt.event.KeyEvent evt) {
        jtfGradosKeyTyped(evt);
      }
    });
    getContentPane().add(jtfGradosC);
    jtfGradosC.setBounds(132, 28, 144, 20);

    jlbGradosF.setText("Grados fahrenheit");
    getContentPane().add(jlbGradosF);
    jlbGradosF.setBounds(12, 68, 104, 24);

    jtfGradosF.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    jtfGradosF.setText("32.00");
    jtfGradosF.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(java.awt.event.FocusEvent evt) {
        jtfGradosFocusGained(evt);
      }
    });
    jtfGradosF.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyTyped(java.awt.event.KeyEvent evt) {
        jtfGradosKeyTyped(evt);
      }
    });
    getContentPane().add(jtfGradosF);
    jtfGradosF.setBounds(132, 72, 144, 20);

    jbtAceptar.setMnemonic('A');
    jbtAceptar.setText("Aceptar");
    getRootPane().setDefaultButton(jbtAceptar);
    jbtAceptar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jbtAceptarActionPerformed(evt);
      }
    });
    getContentPane().add(jbtAceptar);
    jbtAceptar.setBounds(132, 120, 144, 24);
  }// </editor-fold>//GEN-END:initComponents
  
  private void formWindowOpened (java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
    jtfGradosC.requestFocus();
  }//GEN-LAST:event_formWindowOpened
        
  /** Salir de la aplicación */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      System.exit(0);
    }//GEN-LAST:event_exitForm

    private void jbtAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtAceptarActionPerformed
      try {
        double grados;
        // Si se escribió en la caja de texto grados centígrados ...
        if(objJTextField == jtfGradosC) {
          grados = Double.parseDouble(jtfGradosC.getText()) * 9.0 / 5.0 + 32.0;
          String texto = String.format("%.2f", grados); // redondear a dos decimales
          jtfGradosF.setText(texto);
        }
        // Si se escribió en la caja de texto grados fahrenheit ...
        if(objJTextField == jtfGradosF) {
          grados =(Double.parseDouble(jtfGradosF.getText()) - 32.0) * 5.0 / 9.0;
          String texto = String.format("%.2f", grados); // redondear a dos decimales
          jtfGradosC.setText(texto);
        }
      } catch(NumberFormatException e) {
        jtfGradosC.setText("0.00");
        jtfGradosF.setText("32.00");
      }
    }//GEN-LAST:event_jbtAceptarActionPerformed

    private void jtfGradosKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jtfGradosKeyTyped
      objJTextField = evt.getSource(); // objeto que produjo el evento
    }//GEN-LAST:event_jtfGradosKeyTyped

    private void jtfGradosFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jtfGradosFocusGained
      javax.swing.JTextField objEnfocado =(javax.swing.JTextField)evt.getSource();
      objEnfocado.selectAll();
    }//GEN-LAST:event_jtfGradosFocusGained
    
    /**
     * @parámetro args: argumentos en la línea de órdenes
     */
    public static void main(String[] args)
    {
      try
      {
        // Aspecto de la interfaz gráfica
        javax.swing.UIManager.setLookAndFeel(
        javax.swing.UIManager.getSystemLookAndFeelClassName());
      }
      catch(Exception e)
      {
        System.out.println("No se pudo establecer el aspecto deseado: " + e);
      }
      new Conver().setVisible(true);
    }
    
    // Declaración de variables miembro de la clase
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton jbtAceptar;
  private javax.swing.JLabel jlbGradosC;
  private javax.swing.JLabel jlbGradosF;
  private javax.swing.JTextField jtfGradosC;
  private javax.swing.JTextField jtfGradosF;
  // End of variables declaration//GEN-END:variables
  private Object objJTextField;
}