/*
 * Conver.java
 */

package Cap02.Conver_1;

/**
 *
 * @autor  Fco. Javier Ceballos
 * @versión 1.1
 */
public class Conver extends javax.swing.JFrame
{
  /** Crear un nuevo formulario Conver */
  public Conver()
  {
    setSize(300, 150);                      // tamaño del formulario
    setTitle("Conversión de temperaturas"); // título del formulario
    initComponents();                       // iniciar componentes
  }
  
  /** Este método es llamado por el constructor para
   *  iniciar el formulario.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jlbGradosC = new javax.swing.JLabel();
    jtfGradosC = new javax.swing.JTextField();
    jlbGradosF = new javax.swing.JLabel();
    jtfGradosF = new javax.swing.JTextField();

    getContentPane().setLayout(null);

    addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowOpened(java.awt.event.WindowEvent evt)
      {
        formWindowOpened(evt);
      }
      public void windowClosing(java.awt.event.WindowEvent evt)
      {
        exitForm(evt);
      }
    });

    jlbGradosC.setText("Grados cent\u00edgrados");
    getContentPane().add(jlbGradosC);
    jlbGradosC.setBounds(12, 28, 116, 14);

    jtfGradosC.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    jtfGradosC.setText("0.00");
    jtfGradosC.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(java.awt.event.KeyEvent evt)
      {
        jtfGradosKeyPressed(evt);
      }
    });
    jtfGradosC.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jtfGradosActionPerformed(evt);
      }
    });
    jtfGradosC.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyTyped(java.awt.event.KeyEvent evt)
      {
        jtfGradosKeyTyped(evt);
      }
    });
    jtfGradosC.addFocusListener(new java.awt.event.FocusAdapter()
    {
      public void focusGained(java.awt.event.FocusEvent evt)
      {
        jtfGradosFocusGained(evt);
      }
    });
    jtfGradosC.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyReleased(java.awt.event.KeyEvent evt)
      {
        jtfGradosKeyReleased(evt);
      }
    });

    getContentPane().add(jtfGradosC);
    jtfGradosC.setBounds(132, 28, 144, 19);

    jlbGradosF.setText("Grados fahrenheit");
    getContentPane().add(jlbGradosF);
    jlbGradosF.setBounds(12, 68, 104, 24);

    jtfGradosF.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
    jtfGradosF.setText("32.00");
    jtfGradosF.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(java.awt.event.KeyEvent evt)
      {
        jtfGradosKeyPressed(evt);
      }
    });
    jtfGradosF.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jtfGradosActionPerformed(evt);
      }
    });
    jtfGradosF.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyTyped(java.awt.event.KeyEvent evt)
      {
        jtfGradosKeyTyped(evt);
      }
    });
    jtfGradosF.addFocusListener(new java.awt.event.FocusAdapter()
    {
      public void focusGained(java.awt.event.FocusEvent evt)
      {
        jtfGradosFocusGained(evt);
      }
    });
    jtfGradosF.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyReleased(java.awt.event.KeyEvent evt)
      {
        jtfGradosKeyReleased(evt);
      }
    });

    getContentPane().add(jtfGradosF);
    jtfGradosF.setBounds(132, 72, 144, 19);

  }//GEN-END:initComponents
  
  private void jtfGradosActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jtfGradosActionPerformed
    try
    {
      double grados;
      String sgrados;
      Object objJTextField = evt.getSource();
      // Si se escribió en la caja de texto grados centígrados ...
      if (objJTextField == jtfGradosC)
      {
        sgrados = jtfGradosC.getText();
        if (sgrados.length() == 0) return; // caja vacía
        grados = Double.parseDouble(sgrados) * 9.0 / 5.0 + 32.0;
        String texto = String.format("%.2f", grados); // redondear a dos decimales
        jtfGradosF.setText(texto);
      }
      // Si se escribió en la caja de texto grados fahrenheit ...
      if (objJTextField == jtfGradosF)
      {
        sgrados = jtfGradosF.getText();
        if (sgrados.length() == 0) return; // caja vacía
        grados =(Double.parseDouble(sgrados) - 32.0) * 5.0 / 9.0;
        String texto = String.format("%.2f", grados); // redondear a dos decimales
        jtfGradosC.setText(texto);
      }
    }
    catch(NumberFormatException e)
    {
      jtfGradosC.setText("0.00");
      jtfGradosF.setText("32.00");
    }
  }//GEN-LAST:event_jtfGradosActionPerformed
  
  private void jtfGradosKeyReleased (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jtfGradosKeyReleased
    // Obtener la caja de texto que generó el evento
    javax.swing.JTextField objJTF = (javax.swing.JTextField)evt.getSource();
    // fuente: almacena el contenido de la caja de texto
    String str = objJTF.getText();
    char[] fuente = str.toCharArray();
    // resultado: almacena el contenido de la caja de texto validado
    char[] resultado = new char[fuente.length];
    int j = 0;
    boolean error = false;
    // Almacenar en resultado los caracteres válidos de fuente
    for (int i = 0; i < fuente.length; i++)
    {
      if (fuente[i] >= '0' && fuente[i] <= '9' || fuente[i] == '.' ||
      fuente[i] == '+' || fuente[i] == '-')
        resultado[j++] = fuente[i];
      else
      {
        error = true;
        java.awt.Toolkit.getDefaultToolkit().beep();
      }
    }
    if ( error )
      objJTF.setText(new String(resultado, 0, j));
  }//GEN-LAST:event_jtfGradosKeyReleased
  
  private void jtfGradosKeyPressed (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jtfGradosKeyPressed
    
  }//GEN-LAST:event_jtfGradosKeyPressed
  
  private void formWindowOpened (java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
    jtfGradosC.requestFocus();
  }//GEN-LAST:event_formWindowOpened
  
  private void jtfGradosFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jtfGradosFocusGained
    javax.swing.JTextField objEnfocado =(javax.swing.JTextField)evt.getSource();
    objEnfocado.selectAll();
  }//GEN-LAST:event_jtfGradosFocusGained
  
  private void jtfGradosKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jtfGradosKeyTyped
    
  }//GEN-LAST:event_jtfGradosKeyTyped
  
  /** Salir de la aplicación */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @parámetro args: argumentos en la línea de órdenes
     */
    public static void main(String[] args)
    {
      try
      {
        // Aspecto y percepción de la interfaz gráfica
        javax.swing.UIManager.setLookAndFeel(
        javax.swing.UIManager.getCrossPlatformLookAndFeelClassName());
      }
      catch(Exception e)
      {
        System.out.println("No se pudo establecer el aspecto deseado: " + e);
      }
      new Conver().setVisible(true);
    }
    
    // Declaración de variables miembro de la clase
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jlbGradosC;
  private javax.swing.JLabel jlbGradosF;
  private javax.swing.JTextField jtfGradosC;
  private javax.swing.JTextField jtfGradosF;
  // End of variables declaration//GEN-END:variables
}