/*
 * ArbolTfnos.java
 */

package Cap05.ArbolSimple;

/*
 * Autor  Fco. Javier Ceballos
 */
public class ArbolTfnos extends javax.swing.JFrame
{
  
  /** Crea un nuevo formulario ArbolTfnos */
  public ArbolTfnos()
  {
    initComponents();
    setTitle("Árbol teléfonos");
    setSize(400, 300);
  }
  
  /**
   * Iniciar los componentes del formulario
   */
  private void initComponents()
  {
    jScrollPane1 = new javax.swing.JScrollPane();
    raíz = new javax.swing.tree.DefaultMutableTreeNode("Teléfonos");
    crearNodos(raíz);
    jTree1 = new javax.swing.JTree(raíz);
    jTree1.setEditable(true);
    jTree1.setShowsRootHandles(true);
    javax.swing.tree.DefaultTreeCellRenderer pintor =
      new javax.swing.tree.DefaultTreeCellRenderer();
    pintor.setClosedIcon(new javax.swing.ImageIcon(getClass().getResource("imagenes/telef-colgado.gif")));
    pintor.setOpenIcon(new javax.swing.ImageIcon(getClass().getResource("imagenes/telef-descolgado.gif")));
    pintor.setLeafIcon(new javax.swing.ImageIcon(getClass().getResource("imagenes/sonreir.gif")));
    jTree1.setCellRenderer(pintor);

    jTree1.getSelectionModel().setSelectionMode(
      javax.swing.tree.TreeSelectionModel.SINGLE_TREE_SELECTION);
    modeloÁrbol = (javax.swing.tree.DefaultTreeModel)jTree1.getModel();

    jpmnuAñadirBorrar = new javax.swing.JPopupMenu();
    jpmItemAñadirNodo = new javax.swing.JMenuItem();
    jpmItemBorrarNodo = new javax.swing.JMenuItem();
    jpmItemBorrarArbol = new javax.swing.JMenuItem();
    
    jpmItemAñadirNodo.setText("A\u00f1adir nodo");
    jpmItemAñadirNodo.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jpmItemAñadirNodoActionPerformed(evt);
      }
    });

    jpmnuAñadirBorrar.add(jpmItemAñadirNodo);

    jpmItemBorrarNodo.setText("Borrar nodo");
    jpmItemBorrarNodo.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jpmItemBorrarNodoActionPerformed(evt);
      }
    });

    jpmnuAñadirBorrar.add(jpmItemBorrarNodo);

    jpmItemBorrarArbol.setText("Borrar todos los nodos");
    jpmItemBorrarArbol.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        jpmItemBorrarArbolActionPerformed(evt);
      }
    });

    jpmnuAñadirBorrar.add(jpmItemBorrarArbol);

    addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(java.awt.event.WindowEvent evt)
      {
        exitForm(evt);
      }
    });

    jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener()
    {
      public void valueChanged(javax.swing.event.TreeSelectionEvent evt)
      {
        jTree1ValueChanged(evt);
      }
    });

    jTree1.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mousePressed(java.awt.event.MouseEvent evt)
      {
        jTree1MousePressed(evt);
      }
    });

    jScrollPane1.setViewportView(jTree1);

    getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);
  }
  
  /** Crear los nodos del árbol */
  private void crearNodos(javax.swing.tree.DefaultMutableTreeNode raíz)
  {
    javax.swing.tree.DefaultMutableTreeNode categoría = null;
    javax.swing.tree.DefaultMutableTreeNode letra = null;
    javax.swing.tree.DefaultMutableTreeNode teléfono = null;

    categoría = new javax.swing.tree.DefaultMutableTreeNode("Amigos");
    raíz.add(categoría);

    letra = new javax.swing.tree.DefaultMutableTreeNode("A");
    categoría.add(letra);

    teléfono = new javax.swing.tree.DefaultMutableTreeNode(
      new CTfno("Alfons", "Barcelona", 933333333, true));
    letra.add(teléfono);

    teléfono = new javax.swing.tree.DefaultMutableTreeNode(
      new CTfno("Ana", "Pontevedra", 986666666, true));
    letra.add(teléfono);

    letra = new javax.swing.tree.DefaultMutableTreeNode("B");
    categoría.add(letra);

    teléfono = new javax.swing.tree.DefaultMutableTreeNode(
      new CTfno("Beatriz", "Santander", 942222222, false));
    letra.add(teléfono);

    categoría = new javax.swing.tree.DefaultMutableTreeNode("Clientes");
    raíz.add(categoría);
    
    letra = new javax.swing.tree.DefaultMutableTreeNode("A");
    categoría.add(letra);

    teléfono = new javax.swing.tree.DefaultMutableTreeNode(
      new CTfno("Antonio", "Granada", 956666666, true));
    letra.add(teléfono);

    // ...
  }
  
  // Se ha seleccionado un nodo
  private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt)
  {
    javax.swing.tree.DefaultMutableTreeNode nodoSelec =
      (javax.swing.tree.DefaultMutableTreeNode)
      jTree1.getLastSelectedPathComponent();

    if (nodoSelec == null || nodoSelec.isRoot()) return;

    Object nodoUsuario = nodoSelec.getUserObject();
    if (nodoUsuario instanceof CTfno)
      javax.swing.JOptionPane.showMessageDialog(
                          null, ((CTfno)nodoUsuario).datosTfno());
  }

  private void jTree1MousePressed(java.awt.event.MouseEvent evt)
  {
    // Si se pulsó el botón derecho, visualizar el menú emergente
    if (evt.getButton() == java.awt.event.MouseEvent.BUTTON3)
      jpmnuAñadirBorrar.show(jTree1, evt.getX(), evt.getY());
  }

  private void jpmItemAñadirNodoActionPerformed(
                                  java.awt.event.ActionEvent evt)
  {
    // Ruta del nodo elegido como padre del nodo a añadir
    javax.swing.tree.TreePath rutaPadre = jTree1.getSelectionPath();
    if (rutaPadre == null) return; // no hay un nodo seleccionado
    // Nodo elegido como padre
    javax.swing.tree.DefaultMutableTreeNode nodoPadre =
      (javax.swing.tree.DefaultMutableTreeNode)rutaPadre.getLastPathComponent();
    // Crear el nodo hijo
    javax.swing.tree.DefaultMutableTreeNode nodoHijo = null;
    switch(nodoPadre.getLevel())
    {
      case 0: // nodo categoría
        nodoHijo = 
          new javax.swing.tree.DefaultMutableTreeNode("Categoría");
        break;
      case 1: // nodo letra
        nodoHijo =
          new javax.swing.tree.DefaultMutableTreeNode("Letra");
        break;
      case 2: // nodo teléfono
        nodoHijo = new javax.swing.tree.DefaultMutableTreeNode(
               new CTfno("nombre", "dirección", 000000000, false));
        break;
      default:
        return;
    }
  
    // Insertar el nodo
    modeloÁrbol.insertNodeInto(nodoHijo, nodoPadre, 
                               nodoPadre.getChildCount());

    // Asegurarse de que el nodo añadido será visto por el usuario
    jTree1.scrollPathToVisible(
      new javax.swing.tree.TreePath(nodoHijo.getPath()));
  }

  private void jpmItemBorrarNodoActionPerformed(java.awt.event.ActionEvent evt)
  {
    // Ruta del nodo seleccionado
    javax.swing.tree.TreePath rutaNodoSelec = jTree1.getSelectionPath();
    if (rutaNodoSelec == null) return;

    // Nodo seleccionado
    javax.swing.tree.DefaultMutableTreeNode nodoSelec =
                      (javax.swing.tree.DefaultMutableTreeNode)
                         (rutaNodoSelec.getLastPathComponent());

    if (nodoSelec.isRoot()) return; // nodo raíz
    // Borrar el nodo seleccionado
    modeloÁrbol.removeNodeFromParent(nodoSelec);
  }

  private void jpmItemBorrarArbolActionPerformed(java.awt.event.ActionEvent evt)
  {
    raíz.removeAllChildren(); // borrar todos los nodos
    modeloÁrbol.reload();     // refrescar la vista
  }

  /** Salir de la aplicación */
  private void exitForm(java.awt.event.WindowEvent evt)
  {
    System.exit(0);
  }
  
  public static void main(String args[])
  {
    new ArbolTfnos().setVisible(true);
  }
  
  // Declaración de variables
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JTree jTree1;
  private javax.swing.tree.DefaultMutableTreeNode raíz;
  private javax.swing.JPopupMenu jpmnuAñadirBorrar;
  private javax.swing.JMenuItem jpmItemAñadirNodo;
  private javax.swing.JMenuItem jpmItemBorrarNodo;
  private javax.swing.JMenuItem jpmItemBorrarArbol;
  private javax.swing.tree.DefaultTreeModel modeloÁrbol;
}
