/*
 * TablaTfnos.java
 *
 * Autor:  Fco. Javier Ceballos
 */

package Cap05.TablaSimple;

public class TablaTfnos extends javax.swing.JFrame
{
  /** Crear un formulario TablaTfnos */
  public TablaTfnos()
  {
    initComponents();
    setTitle("Teléfonos");
    setSize(500, 300);
  }
  
  /* Iniciar los componentes */
  private void initComponents()
  {

    // Datos para la tabla
    Object[][] datos =  new Object[][]
    {
      {"Alfons González Pérez", "Argentona, Barcelona", new Long(933333333), new Boolean(true)},
      {"Ana María Cuesta Suñer", "Gijón, Asturias", new Long(984454545), new Boolean(false)},
      {"Elena Veiguela Suárez", "Pontevedra", new Long(986678678), new Boolean(false)},
      {"Pedro Aguado Rodríguez", "Madrid", new Long(912804574), new Boolean(true)}
    };
    
    // Cabeceras para las columnas de la tabla
    String[] cabeceras = new String[]
    {
      "Nombre", "Dirección", "Teléfono", "Casado"
    };

    jScrollPanel1 = new javax.swing.JScrollPane();
    jTabla1 = new javax.swing.JTable();

    jTabla1.setModel(new javax.swing.table.DefaultTableModel(datos, cabeceras)
    {
      Class[] tipoColumn = { java.lang.String.class,
                             java.lang.String.class,
                             java.lang.Long.class,
                             java.lang.Boolean.class };

      boolean[] editColum = { false, true, true, true };

      public Class getColumnClass(int indColum)
      {
        return tipoColumn[indColum];
      }

      public boolean isCellEditable(int indFila, int indColum)
      {
        return editColum[indColum];
      }
    });

    javax.swing.table.TableColumn colum = null;
    for (int i = 0; i < jTabla1.getColumnCount(); i++)
    {
      colum = jTabla1.getColumnModel().getColumn(i);
      if (i < 2)
        colum.setPreferredWidth(110);
      else
        colum.setPreferredWidth(40);
    }

    jTabla1.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        jTabla1MouseClicked(evt);
      }
    });
    
    jScrollPanel1 = new javax.swing.JScrollPane(jTabla1);

    addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(java.awt.event.WindowEvent evt)
      {
        exitForm(evt);
      }
    });

    getContentPane().add(jScrollPanel1, java.awt.BorderLayout.CENTER);
  }
  
  private void jTabla1MouseClicked(java.awt.event.MouseEvent evt)
  {
    java.lang.Object datoCelda =jTabla1.getValueAt(
                                     jTabla1.getSelectedRow(),
                                     jTabla1.getSelectedColumn());
    System.out.println(datoCelda);
  }

  /** Salir de la aplicación */
  private void exitForm(java.awt.event.WindowEvent evt)
  {
    System.exit(0);
  }
  
  public static void main(String[] args)
  {
    new TablaTfnos().setVisible(true);
  }
  
  // Declaración de variables
  private javax.swing.JScrollPane jScrollPanel1;
  private javax.swing.JTable jTabla1;
}
