/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mostrartabladesktopap;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 *
 * @author Francisco
 */
@Entity
@Table(name = "telefonos")
@NamedQueries({@NamedQuery(name = "Telefonos.findByNombre", query = "SELECT t FROM Telefonos t WHERE t.nombre = :nombre"), @NamedQuery(name = "Telefonos.findByDireccion", query = "SELECT t FROM Telefonos t WHERE t.direccion = :direccion"), @NamedQuery(name = "Telefonos.findByTelefono", query = "SELECT t FROM Telefonos t WHERE t.telefono = :telefono"), @NamedQuery(name = "Telefonos.findByObservaciones", query = "SELECT t FROM Telefonos t WHERE t.observaciones = :observaciones")})
public class Telefonos implements Serializable {
  @Transient
  private PropertyChangeSupport changeSupport = new PropertyChangeSupport(this);
  private static final long serialVersionUID = 1L;
  @Column(name = "nombre", nullable = false)
  private String nombre;
  @Column(name = "direccion", nullable = false)
  private String direccion;
  @Id
  @Column(name = "telefono", nullable = false)
  private String telefono;
  @Column(name = "observaciones")
  private String observaciones;

  public Telefonos()
  {
  }

  public Telefonos(String telefono)
  {
    this.telefono = telefono;
  }

  public Telefonos(String telefono, String nombre, String direccion)
  {
    this.telefono = telefono;
    this.nombre = nombre;
    this.direccion = direccion;
  }

  public String getNombre()
  {
    return nombre;
  }

  public void setNombre(String nombre)
  {
    String oldNombre = this.nombre;
    this.nombre = nombre;
    changeSupport.firePropertyChange("nombre", oldNombre, nombre);
  }

  public String getDireccion()
  {
    return direccion;
  }

  public void setDireccion(String direccion)
  {
    String oldDireccion = this.direccion;
    this.direccion = direccion;
    changeSupport.firePropertyChange("direccion", oldDireccion, direccion);
  }

  public String getTelefono()
  {
    return telefono;
  }

  public void setTelefono(String telefono)
  {
    String oldTelefono = this.telefono;
    this.telefono = telefono;
    changeSupport.firePropertyChange("telefono", oldTelefono, telefono);
  }

  public String getObservaciones()
  {
    return observaciones;
  }

  public void setObservaciones(String observaciones)
  {
    String oldObservaciones = this.observaciones;
    this.observaciones = observaciones;
    changeSupport.firePropertyChange("observaciones", oldObservaciones, observaciones);
  }

  @Override
  public int hashCode()
  {
    int hash = 0;
    hash += (telefono != null ? telefono.hashCode() : 0);
    return hash;
  }

  @Override
  public boolean equals(Object object)
  {
    // TODO: Warning - this method won't work in the case the id fields are not set
    if (!(object instanceof Telefonos))
    {
      return false;
    }
    Telefonos other = (Telefonos) object;
    if ((this.telefono == null && other.telefono != null) || (this.telefono != null && !this.telefono.equals(other.telefono)))
    {
      return false;
    }
    return true;
  }

  @Override
  public String toString()
  {
    return "mostrartabladesktopap.Telefonos[telefono=" + telefono + "]";
  }

  public void addPropertyChangeListener(PropertyChangeListener listener)
  {
    changeSupport.addPropertyChangeListener(listener);
  }

  public void removePropertyChangeListener(PropertyChangeListener listener)
  {
    changeSupport.addPropertyChangeListener(listener);
  }

}
