// Clase CBaseDeDatos.
// Métodos:
//    CBaseDeDatos: carga el controlador JDBC e invoca a conectar.
//    conectar: realiza la conexión con la base de datos.
//    cerrarConexion: cerrar la conexión con la base de datos.
//    obtenerTabla: obtiene todas las filas de la tabla.
public class CBaseDeDatos
{
  private java.sql.Connection conexión;
  private java.sql.Statement sentenciaSQL;
  private java.sql.ResultSet cdr; // conjunto de resultados

  public CBaseDeDatos(String controlador, String URL_bd,
    String usuario, String contraseña)
    throws ClassNotFoundException, java.sql.SQLException,
    InstantiationException, IllegalAccessException
  {
    // Cargar el controlador JDBC
    Class.forName(controlador).newInstance();
    // Conectar con la fuente de datos
    conectar(URL_bd, usuario, contraseña);
  }

  private void conectar(String URL_bd, String usuario,
    String contraseña) throws java.sql.SQLException
  {
    // Conectar con la BD
    conexión = java.sql.DriverManager.getConnection(
      URL_bd, usuario, contraseña);
    // Crear una sentencia SQL
    sentenciaSQL = conexión.createStatement(
      java.sql.ResultSet.TYPE_SCROLL_INSENSITIVE,
      java.sql.ResultSet.CONCUR_UPDATABLE);
    System.out.println("Conexión realizada con éxito.\n");
  }

  public void cerrarConexion() throws java.sql.SQLException
  {
    if (cdr != null) cdr.close();
    if (sentenciaSQL != null) sentenciaSQL.close();
    if (conexión != null) conexión.close();
  }

  public java.sql.ResultSet obtenerTabla(String tabla)
    throws java.sql.SQLException
  {
    cdr = sentenciaSQL.executeQuery("SELECT * FROM " + tabla);
    return cdr;
  }
}
  

