// Aplicación para probar la base de datos identificada por BD
//
package Cap07.Resueltos.Base_de_datos;

public class PruebaConexion
{
  private static BDAlumnos BD;
  
  public PruebaConexion() throws ClassNotFoundException,
      java.sql.SQLException, InstantiationException,
      IllegalAccessException
  {
    // Realizar la conexión con la base de datos BD
    BD = new BDAlumnos();
  }
  
  public void buscarFilasEnAlumnos()
      throws java.sql.SQLException
  {
    System.out.println("\nBuscar:");
    String[] búsquedas = {"cadenas que empiecen por...",
                          "cadenas que contengan..." };
    int i = menú(búsquedas, búsquedas.length);
    
    System.out.print("> ");
    String subcadena = Leer.dato();
    
    BD.mostrarFilasDeAlumnos(subcadena, i);
  }
  
  public void insertarFilaEnAlumnos()
      throws java.sql.SQLException
  {
    int ID, curso, titulación;
    String apellidos, nombre;
    
    System.out.print("\nID: ");
    ID = Leer.datoInt();
    System.out.print("Apellidos: ");
    apellidos = Leer.dato();
    System.out.print("Nombre: ");
    nombre = Leer.dato();
    System.out.print("Curso: ");
    curso = Leer.datoInt();
    System.out.print("Titulación: ");
    titulación = Leer.datoInt();
    
    BD.insertarFilaEnAlumnos(ID, apellidos, nombre, curso, titulación);
  }
    
  public void borrarFilaEnAlumnos()
      throws java.sql.SQLException
  {
    int ID;

    System.out.print("\nIdentificador: ");
    ID = Leer.datoInt();
    BD.borrarFilaEnAlumnos(ID);
  }
  
  public void navegar() throws java.sql.SQLException
  {
    // Opciones del menú
    String[] opciones = { "Siguiente",
                          "Anterior",
                          "Primero",
                          "último",
                          "Salir." };
     int opción = 0;
     do
     {
        switch(opción = menú(opciones, opciones.length))
        {
          case 1:
            BD.siguiente();
            break;
          case 2:
            BD.anterior();
            break;
          case 3:
            BD.primero();
            break;
          case 4:
            BD.último();
            break;
        }
        if (opción != 5) BD.mostrarFilaActual();
     }
     while(opción != 5);
  }
  
  public static int menú(String[] opciones, int numOpciones)
  {
    int i = 0, opción = 0;
    
    System.out.println("\n____________________________________\n");
    for (i = 1; i <= numOpciones; ++i)
    {
      System.out.print("    " + i + ". " + opciones[i-1] + "\n");
    }
    System.out.println("____________________________________\n");
    do
    {
      System.out.print("\nOpción (1 - " + numOpciones + "): ");
      opción = Leer.datoInt();
    }
    while(opción < 1 || opción > numOpciones);
    return opción;
  }
  
  public static void main(String[] args)
  {
    int i = 0, opción = 0;
    PruebaConexion objAp = null;

    try
    {
      objAp = new PruebaConexion();

      // Opciones del menú
      String[] opciones = { "Datos de la tabla",
                            "Buscar filas en \"alumnos\"",
                            "Insertar fila en \"alumnos\"",
                            "Borrar fila en \"alumnos\"",
                            "Navegar",
                            "Salir." };
      // Nombre de las tablas de la base
      String[] tablas = BD.tablas();

      do
      {
        switch(opción = PruebaConexion.menú(opciones, opciones.length))
        {
          case 1:
            i = PruebaConexion.menú(tablas, tablas.length);
            BD.mostrarTabla(tablas[i-1]);
            break;
          case 2:
            objAp.buscarFilasEnAlumnos();
            break;
          case 3:
            objAp.insertarFilaEnAlumnos();
            break;
          case 4:
            objAp.borrarFilaEnAlumnos();
            break;
          case 5:
            i = PruebaConexion.menú(tablas, tablas.length);
            BD.obtenerTabla(tablas[i-1]);
            objAp.navegar();
            break;
        }
      }
      while (opción != 6);
    }
    catch(ClassNotFoundException e)
    {
      System.out.println(e.getMessage());  
    }
    catch(InstantiationException e)
    {
      System.out.print(e.getMessage());
    }
    catch(IllegalAccessException e)
    {
      System.out.print(e.getMessage());
    }
    catch(java.sql.SQLException e)
    {
      System.out.print(e.getMessage());
    }
    finally  // pase lo que pase cerramos la conexión
    {
      try
      {
        BD.cerrarConexion();
      }
      catch(java.sql.SQLException ignorada) {}
    }
  }
}
