import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

/**
 *
 * @author  Fco. Javier Ceballos
 */
public class CVistaTabla extends javax.swing.JFrame
{
  public CVistaTabla()
  {
    initComponents();
  }

  private void initComponents()
  {
    try
    {
      // Panel raíz
      jpnPanelRaiz = (JPanel) this.getContentPane();
      jpnPanelRaiz.setLayout(new BorderLayout());

      // Añadir un panel con pestañas al panel raíz
      jtpnPaneles = new JTabbedPane();
      jpnPanelRaiz.add(jtpnPaneles, BorderLayout.CENTER);

      // Crear el panel de conexión y añadirlo al JTabbedPane
      jpnPanelConexion = crearPanelConexion();
      jtpnPaneles.addTab("Conexión", jpnPanelConexion);

      // Crear un modelo, inicialmente vacío, para el objeto JTable
      ModeloTabla = new CModeloTabla();

      // Crear el panel de consulta y añadirlo al JTabbedPane
      jpnPanelConsulta = crearPanelConsulta(ModeloTabla);
      jtpnPaneles.addTab("Consulta", jpnPanelConsulta);

      // Fijar el tamaño de la ventana principal
      this.setSize(500, 300);
      // Exit al cerrar la ventana
      addWindowListener(new java.awt.event.WindowAdapter()
      {
        public void windowClosing(java.awt.event.WindowEvent evt)
        {
          salir();
        }
      }
      );
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  // Salir de la aplicación
  private void salir()
  {
    ModeloTabla.cerrar();
    System.out.println("Aplicación finalizada.\n");
    System.exit(0);
  }

  // Crear el panel de conexión
  private JPanel crearPanelConexion()
  {
    // jpnConexion = jpnControles + jbtConexion
    JPanel jpnConexion = new JPanel();
    jpnConexion.setLayout(new BorderLayout());
    // jpnControles = filas de controles
    JPanel jpnControles = new JPanel();
    jpnControles.setLayout(new BoxLayout(jpnControles, BoxLayout.PAGE_AXIS));
    // Primera fila de controles
    JPanel jpnFilaDeCtrls = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel jlbControlador = new JLabel("Controlador:");
    Vector controladores = new Vector();
    controladores.add("com.mysql.jdbc.Driver");     // local
    controladores.add("org.gjt.mm.mysql.Driver");   // remoto
    jcbControlador = new JComboBox(controladores);
    jpnFilaDeCtrls.add(jlbControlador);
    jpnFilaDeCtrls.add(jcbControlador);
    jpnControles.add(jpnFilaDeCtrls);
    // Segunda fila de controles
    jpnFilaDeCtrls = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel jlbURL = new JLabel("URL BD:");
    Vector URLs = new Vector();
    URLs.add("jdbc:mysql://localhost:3306/");     // local
    URLs.add("jdbc:mysql://servidor.com:3306/");  // remoto
    jcbURL = new JComboBox(URLs);
    jpnFilaDeCtrls.add(jlbURL);
    jpnFilaDeCtrls.add(jcbURL);
    jpnControles.add(jpnFilaDeCtrls);
    // Tercera fila de controles
    jpnFilaDeCtrls = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel jlbBaseDatos = new JLabel("Base de datos:");
    jtfBaseDatos = new JTextField(10);
    jtfBaseDatos.setText("bd_telefonos");
    jpnFilaDeCtrls.add(jlbBaseDatos);
    jpnFilaDeCtrls.add(jtfBaseDatos);
    jpnControles.add(jpnFilaDeCtrls);
    // Cuarta fila de controles
    jpnFilaDeCtrls = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel jlbTablaBD = new JLabel("Tabla de la BD:");
    jtfTablaBD = new JTextField(10);
    jtfTablaBD.setText("telefonos");
    jpnFilaDeCtrls.add(jlbTablaBD);
    jpnFilaDeCtrls.add(jtfTablaBD);
    jpnControles.add(jpnFilaDeCtrls);
    // Quinta fila de controles
    jpnFilaDeCtrls = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel jlbUsuario = new JLabel("Usuario:");
    jtfUsuario = new JTextField(10);
    jpnFilaDeCtrls.add(jlbUsuario);
    jpnFilaDeCtrls.add(jtfUsuario);
    jpnControles.add(jpnFilaDeCtrls);
    // Sexta fila de controles
    jpnFilaDeCtrls = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel jlbContraseña = new JLabel("Contraseña:");
    jtfContraseña = new JTextField(10);
    jpnFilaDeCtrls.add(jlbContraseña);
    jpnFilaDeCtrls.add(jtfContraseña);
    jpnControles.add(jpnFilaDeCtrls);
    // Botón para realizar la conexión
    jbtConexion = new JButton("Realizar la conexión");
    jbtConexion.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jbtConexion_clic(e);
      }
    });
    // Añadir el panel de controles y el botón al panel de conexión
    jpnConexion.add(jpnControles, BorderLayout.CENTER);
    jpnConexion.add(jbtConexion, BorderLayout.SOUTH);
    return jpnConexion;
  }

  // Crear el panel de consulta que contiene el objeto JTable
  private JPanel crearPanelConsulta(CModeloTabla ModeloTabla)
  {
    JPanel jpnConsulta = new JPanel();
    jpnConsulta.setLayout(new BorderLayout());
    // Crear una tabla con el modelo de datos ModeloTabla
    jtbTabla = new JTable(ModeloTabla);
    JScrollPane jpnScrollPanel = new JScrollPane(jtbTabla);
    // Añadir la tabla al panel de consulta
    jpnConsulta.add(jpnScrollPanel, BorderLayout.CENTER);
    return jpnConsulta;
  }

  // Respuesta al evento clic del botón conexión
  public void jbtConexion_clic(ActionEvent e)
  {
    String URL_bd = (String) jcbURL.getSelectedItem() +
      jtfBaseDatos.getText();
    try
    {
      ModeloTabla.iniciar((String)jcbControlador.getSelectedItem(),
        URL_bd, jtfTablaBD.getText(),
        jtfUsuario.getText(), jtfContraseña.getText());
    }
    catch (Exception exc)
    {
      exc.printStackTrace();
    }
    jtpnPaneles.setSelectedComponent(jpnPanelConsulta);
  }

  // Punto de entrada a la aplicación
  public static void main(String[] args)
  {
    java.awt.EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new CVistaTabla().setVisible(true);
      }
    });
  }
  JPanel jpnPanelRaiz;      // panel raíz
  JTabbedPane jtpnPaneles;  // panel contenedor paneles
  JPanel jpnPanelConexion;  // panel para la conexión con la BD
  JPanel jpnPanelConsulta;  // panel de consulta de datos
  JComboBox jcbControlador; // controlador para acceso a la BD
  JComboBox jcbURL;         // URL de la base de datos
  JTextField jtfBaseDatos;  // nombre de la base de datos (BD)
  JTextField jtfTablaBD;    // nombre de la tabla de la BD
  JTextField jtfUsuario;    // usuario
  JTextField jtfContraseña; // contraseña
  JButton jbtConexion;      // botón para realizar la conexión
  JTable jtbTabla;          // tabla para mostrar los datos
  CModeloTabla ModeloTabla; // modelo para el objeto JTable
}
