USE master

if exists (select * from sysdatabases where name='bd_alumnnos')
begin
  raiserror('La base de datos existe; eliminndola....',0,1)
  DROP database bd_alumnnos
end
GO

raiserror('Creando base de datos bd_alumnnos....',0,1)
GO

CREATE DATABASE bd_alumnnos
GO

USE bd_alumnnos
GO

CREATE TABLE alumnos(
                id_alumno  INTEGER PRIMARY KEY,
                apellidos  VARCHAR(24) NOT NULL,
                nombre     VARCHAR(18) NOT NULL,
                curso      INTEGER NOT NULL,
                titulacion INTEGER NOT NULL
)
GO

CREATE TABLE asignaturas(
                id_asignatura INTEGER PRIMARY KEY,
                tipo          VARCHAR(2) NOT NULL,
                nombre        VARCHAR(60) NOT NULL,
                creditos      FLOAT NOT NULL,
)
GO

CREATE TABLE alumnos_asignaturas(
                id_alumno     INTEGER NOT NULL,
                id_asignatura INTEGER NOT NULL,
                cursada       CHAR(1) NOT NULL,
)
GO

raiserror('Base de datos bd_alumnnos creada.',0,1)
GO

raiserror('Cargando datos....',0,1)
GO

BULK INSERT alumnos 
   FROM 'C:\alumnos.txt' 
   WITH (
      DATAFILETYPE='char',
      FIELDTERMINATOR='\t'
)
GO

BULK INSERT asignaturas 
   FROM 'C:\asignaturas.txt' 
   WITH (
      DATAFILETYPE='char',
      FIELDTERMINATOR='\t'
)
GO

BULK INSERT alumnos_asignaturas 
   FROM 'C:\alumnos_asignaturas.txt' 
   WITH (
      DATAFILETYPE='char',
      FIELDTERMINATOR='\t'
)
GO

raiserror('Datos cargados',0,1)
GO
