/*
 * HolaMundo.java
 *
 * autor: Fco. Javier Ceballos
 */

public class HolaMundo extends javax.swing.JApplet implements Runnable
{
  // Atributos
  private String m_Texto;
  private int m_anchoTexto;
  private java.awt.Font m_Fuente;
  private int m_TamanyoFuente;
  private java.awt.Color m_ColorFondo;
  private int m_Rojo;
  private int m_Verde;
  private int m_Azul;
  private Thread m_Hilo;
  private boolean m_Terminar;

  // Métodos
  public void init()
  {
    m_Texto = getParameter("TEXTO");
    if (m_Texto == null)
    {
      m_Texto = "Hola mundo";
    }
    m_TamanyoFuente = Integer.parseInt(getParameter("TAMANYO"));
    if (m_TamanyoFuente <= 0)
    {
      m_TamanyoFuente = 14;
    }
    String fuente = getParameter("FUENTE");
    if (fuente == null)
    {
      m_Texto = "Times New Roman";
    }
    m_Fuente = new java.awt.Font(fuente,
      java.awt.Font.BOLD, m_TamanyoFuente);
    m_ColorFondo = java.awt.Color.white;
    m_anchoTexto = getFontMetrics(m_Fuente).stringWidth(m_Texto);
    m_Rojo = 0;
    m_Verde = 0;
    m_Azul = 0;
    m_Hilo = null;
    m_Terminar = false;
  }

  public void start()
  {
    if (m_Hilo == null)
    {
      m_Hilo = new java.lang.Thread(this);
      m_Hilo.start(); // lanza el hilo que fija el color del texto
    }
  }

  public void run()
  {
    setBackground(m_ColorFondo); // color de fondo
    setFont(m_Fuente);           // tipo de letra
    m_anchoTexto = getFontMetrics(m_Fuente).stringWidth(m_Texto);
    while (!m_Terminar)
    {
      m_Rojo = (int) (Math.random() * 256.0);
      m_Verde = (int) (Math.random() * 256.0);
      m_Azul = (int) (Math.random() * 256.0);
      repaint();
      try
      {
        m_Hilo.sleep(500); // retardo de 500 mseg
      }
      catch (java.lang.InterruptedException ie){}
    }
  }

  public void destroy()
  {
    m_Terminar = true;
  }

  public void paint(java.awt.Graphics g)
  {
    java.awt.Color nuevoColor = new java.awt.Color(m_Rojo, m_Verde, m_Azul);
    g.setColor(nuevoColor);
    g.draw3DRect(3, 3, getSize().width - 6, getSize().height - 6, false);
    g.drawString(m_Texto,
      (int) ((getSize().width - m_anchoTexto) / 2),
      (int) (getSize().height / 2));
  // AWT hace coincidir la coordenada y con la línea base del texto.
  }
}
