/*
 * ModeloTablaTfnos.java
 *
 * Autor:  Fco. Javier Ceballos
 */

public class CModeloTabla extends javax.swing.table.DefaultTableModel
{
  private static CBaseDeDatos BD;
  private java.sql.ResultSet cdr; // conjunto de datos
  private java.sql.ResultSetMetaData info; // información sobre cdr

  // Crear un modelo para una tabla (JTable)
  public CModeloTabla()
  {
  }

  // Iniciar el modelo de datos del JTable
  public void iniciar(String controlador, String URL_bd,
    String tabla_bd, String usuario, String contraseña)
    throws ClassNotFoundException, java.sql.SQLException,
    InstantiationException, IllegalAccessException
  {
    // Abrir una conexión con la base de datos
    BD = new CBaseDeDatos(controlador, URL_bd, usuario, contraseña);
    // Actualizar el modelo de datos con los obtenidos de la BD
    cargarDatos(tabla_bd);
  }

  private void cargarDatos(String tabla_bd) throws java.sql.SQLException
  {
    if (cdr != null) cdr.close();
    cdr = BD.obtenerTabla(tabla_bd);
    info = cdr.getMetaData();
    fireTableStructureChanged(); // actualizar el objeto JTable
    System.out.println("Datos cargados.\n");
  }

  public void cerrar() 
  {
    try
    {
      if (cdr != null) cdr.close();
      if (BD != null) BD.cerrarConexion();
      System.out.println("Conexión cerrada con éxito.\n");
    }
    catch (java.sql.SQLException e)
    {
      e.printStackTrace();
    }
  }
/*
  public boolean insertar()
  {
	  try
    {
      // Mover el cursor a "insert row"
      cdr.moveToInsertRow();
      // Valores para la nueva fila
      cdr.updateString("nombre", "new data");
      cdr.updateString("direccion", "new data");
      cdr.updateString("telefono", "new data");
      cdr.updateString("observaciones", "new data");
      // Insertar la fila
      cdr.insertRow();
	    return true;
	  }
	  catch (java.sql.SQLException e)
    {
      e.printStackTrace();
      return false;
    }
  }

  public boolean borrar(int fila)
  {
	  try
    {
	    cdr.absolute(fila + 1);
	    cdr.deleteRow();
	    return true;
	  }
	  catch (java.sql.SQLException e)
    {
      e.printStackTrace();
      return false;
    }
  }
*/
  // Métodos redefinidos de la clase DefaultTableModel: necesarios
  // para crear o actualizar el modelo de datos del JTable:
  
  // Retornar el nombre de la columna especificada
  public String getColumnName(int c)
  {
    try
    {
      if (info != null)
      {
        return info.getColumnName(c + 1);
      }
      return "";
    }
    catch (java.sql.SQLException e)
    {
      e.printStackTrace();
      return "";
    }
  }

  // Retornar el número de columnas de la tabla
  public int getColumnCount()
  {
    try
    {
      if (info != null)
      {
        return info.getColumnCount();
      }
      return 0;
    }
    catch (java.sql.SQLException e)
    {
      e.printStackTrace();
      return 0;
    }
  }

  // Retornar el número de filas de la tabla
  public int getRowCount()
  {
    try
    {
      if (cdr != null)
      {
        cdr.last(); // nos situamos en la última fila
        return cdr.getRow(); // devolvemos el número de la fila
      }
      return 0;
    }
    catch (java.sql.SQLException e)
    {
      e.printStackTrace();
      return 0;
    }
  }

  // Datos de la celda especificada
  public Object getValueAt(int fila, int col)
  {
    try
    {
      if (cdr != null)
      {
        cdr.absolute(fila + 1);
        return cdr.getObject(col + 1);
      }
      return "";
    }
    catch (java.sql.SQLException e)
    {
      e.printStackTrace();
      return null;
    }
  }
}
