/*
 * SvOcio.java
 */
import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class SvOcio extends HttpServlet
{
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);
  }
  
  public void destroy()
  {
  }
  
  protected void procesarPeticion(HttpServletRequest request,
                                HttpServletResponse response)
  throws ServletException, IOException
  {
    Cookie cookies[];
    String nombreCookie = null;
    String valorCookie = null;
    String usuario = null;
    String aficin = null;
    int i = 0, cookiesLocalizadas = 0;
    
    cookies = request.getCookies();
    
    if (cookies != null)
    {
      while (i < cookies.length && cookiesLocalizadas < 2)
      {
        nombreCookie = cookies[i].getName();
        if (nombreCookie.equals("usuario"))
        {
          usuario = (String)cookies[i].getValue();
          cookiesLocalizadas++;
        }
        if (nombreCookie.equals("aficion"))
        {
          aficin = (String)cookies[i].getValue();
          cookiesLocalizadas++;
        }
        i++;
      }
    }
    
    if (cookies != null && usuario != null && aficin != null)
    {
      String destino = null;
      
      if (aficin.equals("leer libros"))
        destino="/libros.html";
      else if (aficin.equals("escuchar musica"))
        destino="/discos.html";
      else if (aficin.equals("ver peliculas"))
        destino="/peliculas.html";
      else
        destino="/error.html";
      
      RequestDispatcher rd = request.getRequestDispatcher(destino);
      rd.forward(request, response);
    }
    else
    {
      // El usuario no envi ninguna cookie.
      // El servlet invoca al formulario usuarionuevo.html (de esta
      // forma, tambin se podra invocar a otro servlet).
      RequestDispatcher rd = request.getRequestDispatcher("/usuarionuevo.html");
      rd.forward(request, response);
      // Otra solucin sera incluir aqu el formulario
      // usuarionuevo.html, en lugar de las dos lneas anteriores.
    }
  }
  
  protected void doGet(HttpServletRequest request,
                       HttpServletResponse response)
  throws ServletException, IOException
  {
    procesarPeticion(request, response);
  }
  
  protected void doPost(HttpServletRequest request,
                        HttpServletResponse response)
  throws ServletException, IOException
  {
    procesarPeticion(request, response);
  }
  
  public String getServletInfo()
  {
    return "Servlet Ocio";
  }
  
}
