/*
 * SvFechaHora.java
 *
 * autor Fco. Javier Ceballos
 */

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

public class SvFechaHora extends HttpServlet
{
  // Manipular las posibles peticiones enviadas por el cliente:
  // utilizando el atributo method=get o method=post.
  protected void procesarPeticion(HttpServletRequest request,
                                  HttpServletResponse response)
  throws ServletException, IOException
  {
    Calendar fechahora = new GregorianCalendar();
    PrintWriter out = response.getWriter();
    // Refrescar la conversacin cada 60 segundos
    out.println("<html><head>" +
      "<meta http-equiv='refresh' " +
            "content='60;" +
            "url=SvFechaHora'>" +
    "</head><body><center><font face='Arial' size='5'>");
    out.println("Fecha: " + 
                fechahora.get(Calendar.DAY_OF_MONTH) + "/" +
                (fechahora.get(Calendar.MONTH)+1) + "/" +
                fechahora.get(Calendar.YEAR) );
    out.println("&nbsp;&nbsp;&nbsp;" + "Hora:  " + 
                fechahora.get(Calendar.HOUR_OF_DAY) + ":" +
                fechahora.get(Calendar.MINUTE) );
    out.println("</font></center></body></html>");
    out.close();
  }
  
   // Manipular la peticin enviada por el cliente
   // utilizando el atributo method=get.
  protected void doGet(HttpServletRequest request,
                       HttpServletResponse response)
  throws ServletException, IOException
  {
    procesarPeticion(request, response);
  }
  
   // Manipular la peticin enviada por el cliente
   // utilizando el atributo method=post.
  protected void doPost(HttpServletRequest request,
                        HttpServletResponse response)
  throws ServletException, IOException
  {
    procesarPeticion(request, response);
  }
  
  // Devuelve una descripcin breve.
  public String getServletInfo()
  {
    return "Servlet SvFechaHora";
  }
}
