// Clase base de datos tutoras (BDTutorias). Mtodos:

import java.sql.*;
import javax.servlet.*;
import javax.sql.*;    // para DataSource

public class BDTutorias
{
  private Connection conexin;
  private Statement sentenciaSQL;
  private ResultSet cdr; // conjunto de resultados
  
  public BDTutorias(DataSource servCon)
  throws java.sql.SQLException, javax.servlet.ServletException
  {
    synchronized (servCon)
    {
      conexin = servCon.getConnection(); // recuperar la conexin
    }
    if(conexin == null)
      throw new ServletException("Problemas con la conexion");
    
    // Crear una sentencia SQL
    sentenciaSQL = conexin.createStatement(
                       ResultSet.TYPE_SCROLL_INSENSITIVE,
                       ResultSet.CONCUR_UPDATABLE);
    System.out.println("\nConexin realizada con xito.\n");
  }
  
  public void cerrarConexion() throws java.sql.SQLException
  {
    if (cdr != null) cdr.close();
    if (sentenciaSQL != null) sentenciaSQL.close();
    if (conexin != null) conexin.close();
  }

  public ResultSet obtenerTabla(String tabla)
      throws SQLException
  {
    cdr = sentenciaSQL.executeQuery("SELECT * FROM " + tabla);
    return cdr;
  }
  
  public ResultSet tutoriasDisponibles()
      throws SQLException
  {
    cdr = sentenciaSQL.executeQuery(
         "SELECT tutorias.id_tutoria, profesores.profesor, " + 
                 "tutorias.dia, tutorias.hora " +
            "FROM profesores, tutorias " +
            "WHERE profesores.id_profesor=tutorias.id_profesor " +
            "AND tutorias.id_tutoria NOT IN " +
            "(SELECT id_tutoria FROM citas)");
    return cdr;
  }
  
  public void insertarEnCitas(int id_tutoria, String alumno, String asunto)
      throws SQLException
  {
    sentenciaSQL.executeUpdate("INSERT INTO citas" +
      " VALUES (" + id_tutoria + ", '" + alumno + "', '" + asunto + "')"
     );
  }

  public void borrarCitas() throws SQLException
  {
    sentenciaSQL.executeUpdate("DELETE FROM citas");
  }
  
  public int obtenerIdProfesor(String nombre) throws SQLException
  {
    cdr = sentenciaSQL.executeQuery(
        "SELECT * FROM profesores" +
           " WHERE profesor = " + "'" + nombre + "'");
    if (cdr.isBeforeFirst())
    {
      cdr.first();
      return cdr.getInt("id_profesor");
    }
    else
      return -1;
  }
  
  public int obtenerIdTutoria(int id_prof, String d, String h)
      throws SQLException
  {
    cdr = sentenciaSQL.executeQuery(
        "SELECT * FROM tutorias" +
           " WHERE id_profesor = " + id_prof + 
           " AND dia = " + "'" + d + "'" +
           " AND hora = " + "'" + h + "'");
    if (cdr.isBeforeFirst())
    {
      cdr.first();
      return cdr.getInt("id_tutoria");
    }
    else
      return -1;
  }
  
  public boolean noEstaReservada(int idT)
      throws SQLException
  {
    cdr = sentenciaSQL.executeQuery(
        "SELECT id_tutoria FROM citas WHERE id_tutoria = " + idT);
    if (cdr.isBeforeFirst())
      return false; // est reservada
    else
      return true; // no est reservada
  }
}
