/*
 * FechaHora.java
 *
 * autor Fco. Javier Ceballos
 */

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

public class FechaHora extends HttpServlet
{
  // Manipular las posibles peticiones enviadas por el cliente:
  // utilizando el atributo method=get o method=post.
  protected void procesarPeticion(HttpServletRequest request,
                                  HttpServletResponse response)
  throws ServletException, IOException
  {
    Calendar fechahora = new GregorianCalendar();
    PrintWriter out = response.getWriter();
    out.println("Fecha: " + 
                fechahora.get(Calendar.DAY_OF_MONTH) + "/" +
                (fechahora.get(Calendar.MONTH)+1) + "/" +
                fechahora.get(Calendar.YEAR) );
    out.println("Hora:  " + 
                fechahora.get(Calendar.HOUR_OF_DAY) + ":" +
                fechahora.get(Calendar.MINUTE) + ":" +
                fechahora.get(Calendar.SECOND) );
    out.close();
  }
  
   // Manipular la peticin enviada por el cliente
   // utilizando el atributo method=get.
  protected void doGet(HttpServletRequest request,
                       HttpServletResponse response)
  throws ServletException, IOException
  {
    procesarPeticion(request, response);
  }
  
   // Manipular la peticin enviada por el cliente
   // utilizando el atributo method=post.
  protected void doPost(HttpServletRequest request,
                        HttpServletResponse response)
  throws ServletException, IOException
  {
    procesarPeticion(request, response);
  }
  
  // Devuelve una descripcin breve.
  public String getServletInfo()
  {
    return "Servlet FechaHora";
  }
}
