/*
 * BDTutorias.java
 *
 * autor Fco. Javier Ceballos
 */
import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class BDTutorias extends HttpServlet
{
  Connection conexin = null;
  Statement sentenciaSQL = null;
  ResultSet cdr = null;

  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);
    try
    {
      // Cargar y registrar el controlador JDBC
      String controlador = "com.mysql.jdbc.Driver";
      Class.forName(controlador).newInstance();   
      // Conectar con la fuente de datos
      conexin = DriverManager.getConnection(
            "jdbc:mysql://127.0.0.1:3306/bd_tutorias", "", "");
      // Crear una sentencia SQL
      sentenciaSQL = conexin.createStatement();
    }
    catch(ClassNotFoundException e)
    { 
      System.out.println("No se pudo cargar el controlador: " +
                         e.getMessage());
    }
    catch(SQLException e)
    { 
      System.out.println("Excepcin SQL: " + e.getMessage());
    }
    catch(InstantiationException e)
    { 
      System.out.println("Objeto no creado. " + e.getMessage());
    }
    catch(IllegalAccessException e)
    { 
      System.out.println("Acceso ilegal. " + e.getMessage());
    }
  }
  
  // Los mensajes puede verlos en <TOMCAT_HOME>\logs
  
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
  throws ServletException, IOException
  {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter(); 

    try
    {
      // Realizar una consulta SQL
      cdr = sentenciaSQL.executeQuery(
        "SELECT profesor, dia, hora, alumno " +
           "FROM profesores, tutorias, citas " +
           "WHERE profesores.id_profesor = tutorias.id_profesor" + 
                  " AND tutorias.id_tutoria = citas.id_tutoria");
     
      // Mostrar el conjunto de resultados obtenido
      out.println("<html><head><title>Tutoras</title></head>");
      out.println("<body>");
      // Tabla
      out.println("<table width=100% border=1>");
      // Cabeceras
      out.println("<tr>");
      out.println("<th>Alumno</th><th>Da/hora</th><th>Con el profesor</th>");
      out.println("</tr>");
      // Filas
      while(cdr.next())
      {
        out.println("<tr>");
        out.println("<td width=40%>" + cdr.getString("alumno") + "</td>");
        out.println("<td width=20%>" + cdr.getString("dia") +
                    " a las " + cdr.getString("hora") + "</td>");
        out.println("<td width=40%>" + cdr.getString("profesor") + "</td>");
        out.println("</tr>");
      } 
      out.println("</table>");
      out.println("</body></html>");
    }
    catch(SQLException e)
    { 
      out.println("Excepcin SQL: " + e.getMessage());
    }
    finally  // cerramos la conexin
    {
      try
      {
        if (cdr != null) cdr.close();
        if (sentenciaSQL != null) sentenciaSQL.close();
        if (conexin != null) conexin.close();
      }
      catch(java.sql.SQLException ignorada) {}
    }
  }
}
/*
 // Sin mtodo init para que los mensajes se muestren en el explorador
import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class BDTutorias extends HttpServlet
{
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
  throws ServletException, IOException
  {
    Connection conexin = null;
    Statement sentenciaSQL = null;
    ResultSet cdr = null;

    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

    try
    {
      // Cargar y registrar el controlador JDBC
      String controlador = "com.mysql.jdbc.Driver";
      Class.forName(controlador).newInstance();
     
      // Conectar con la fuente de datos
      conexin = DriverManager.getConnection(
        "jdbc:mysql://127.0.0.1:3306/bd_tutorias", "", "");
     
      // Crear una sentencia SQL
      sentenciaSQL = conexin.createStatement();
     
      // Realizar una consulta SQL
      cdr = sentenciaSQL.executeQuery(
        "SELECT profesor, dia, hora, alumno " +
           "FROM profesores, tutorias, citas " +
           "WHERE profesores.id_profesor = tutorias.id_profesor" + 
                  " AND tutorias.id_tutoria = citas.id_tutoria");
     
      // Mostrar el conjunto de resultados obtenido
      out.println("<html><head><title>Tutoras</title></head>");
      out.println("<body>");
      // Tabla
      out.println("<table width=100% border=1>");
      // Cabeceras
      out.println("<tr>");
      out.println("<th>Alumno</th><th>Da/hora</th><th>Con el profesor</th>");
      out.println("</tr>");
      // Filas
      while(cdr.next())
      {
        out.println("<tr>");
        out.println("<td width=40%>" + cdr.getString("alumno") + "</td>");
        out.println("<td width=20%>" + cdr.getString("dia") +
                    " a las " + cdr.getString("hora") + "</td>");
        out.println("<td width=40%>" + cdr.getString("profesor") + "</td>");
        out.println("</tr>");
      } 
      out.println("</table>");
      out.println("</body></html>");
    }
    catch(ClassNotFoundException e)
    { 
      out.println("No se pudo cargar el controlador de la BD: " +
                  e.getMessage());
    }
    catch(SQLException e)
    { 
      out.println("Excepcin SQL: " + e.getMessage());
    }
    catch(InstantiationException e)
    { 
      out.println(e.getMessage());
    }
    catch(IllegalAccessException e)
    { 
      out.println(e.getMessage());
    }
    finally  // cerramos la conexin
    {
      try
      {
        if (cdr != null) cdr.close();
        if (sentenciaSQL != null) sentenciaSQL.close();
        if (conexin != null) conexin.close();
      }
      catch(java.sql.SQLException ignorada) {}
    }
  }
}
 */
