/*
 * CancelacionManual.java
 *
 * autor Fco. Javier Ceballos
 */

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CancelacionManual extends HttpServlet
{
  public void doGet(HttpServletRequest request, 
                    HttpServletResponse response)
  throws ServletException, IOException
  {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>Cancelacin manual</title></head>");
    out.println("<body><center>");

    // Obtener la sesin actual; crear una si fuera necesario.
    HttpSession sesin = request.getSession(true);
    
    // Cancelar la sesin si transcurrieron ms de 3 horas desde
    // que fue creada o ha permanecido inactiva ms de 10 minutos.
    if (!sesin.isNew()) // si la sesin no es nueva
    {  
      out.println("<p><h3>Sesin en curso</h3></p>");
      Date transcurrido = new Date(System.currentTimeMillis() -
                                   3*60*60*1000);
      Date inactividad = new Date(System.currentTimeMillis() -
                                   10*60*1000);
      Date creada = new Date(sesin.getCreationTime());
      Date accedida = new Date(sesin.getLastAccessedTime());

      if (creada.before(transcurrido) || accedida.before(inactividad))
      {
        sesin.invalidate();
        out.println("<p><h3>Sesin cancelada</h3></p>");
        sesin = request.getSession(true);  // una nueva sesin
        out.println("<p><h3>Se inicia una sesin nueva</h3></p>");
      }
    }
    else
      out.println("<p><h3>Sesin nueva</h3></p>");
    out.println("</center></body></html>");

    // Continuacin del proceso...
  }
}
