/*
 * Tutorias.java
 *
 * autor Fco. Javier Ceballos
 */

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

public class Tutorias extends HttpServlet
{
  String carpeta = null;

  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);
    carpeta = getInitParameter("carpeta");
      // parmetro establecido en el fichero web.xml que se
      // localiza en la carpeta WEB-INF del servidor
    if (carpeta == null)
    {
      System.err.println("No se especific la carpeta de destino");
    }
  }

  // Manipular la peticin enviada por el cliente
  // utilizando el atributo method=post.
  protected void doPost(HttpServletRequest request,
                        HttpServletResponse response)
  throws ServletException, IOException
  {
    // Tipo de la respuesta que ser enviada al cliente
    response.setContentType("text/html");

    // Obtener el objeto 'PrintWriter' para devolver la respuesta
    PrintWriter out = response.getWriter();
    // Registrar la tutora
    try
    {
      // Abrir el fichero para el registro de la tutora solicitada
      FileWriter fw = new FileWriter(carpeta + "/tutorias.txt", true);
      PrintWriter fichTutorias = new PrintWriter(fw);

      // Tomar los datos recibidos del cliente y escribirlos
      // en el fichero. Se finaliza cada registro con la marca
      // <FIN> para su posterior identificacin.
      Enumeration nombresParams = request.getParameterNames();
      while (nombresParams.hasMoreElements())
      {
        String param = (String)nombresParams.nextElement();
        String valor = request.getParameter(param);
        fichTutorias.println(param + ": " + valor);
      }
      fichTutorias.println("<FIN>");

      // Cerrar el fichero
      fichTutorias.close(); 
      fw.close();

      // Responder al cliente
      out.println("<html>");
      out.println("<title>Respuesta a la solicitud</title>");
      out.println("Su peticin ha sido registrada<br>Un saludo");
      out.println("</html>");
    }
    catch(IOException e)
    {
      out.println("Hubo problemas cursando su solicitud." +
                  "<br>Por favor, intntelo otra vez.");
    }

    // Cerrar el flujo
    out.close();
  }
  
  // Devuelve una descripcin breve.
  public String getServletInfo()
  {
    return "Servlet Tutoras";
  }
}
